﻿using System.Collections.Generic;
using System.Web.Mvc;
using System.Web.Routing;
using Orchard.Mvc.Routes;

namespace Amba.DownloadsCounter
{
    public class Routes : IRouteProvider
    {
        #region IRouteProvider Members

        public void GetRoutes(ICollection<RouteDescriptor> routes)
        {
            foreach (RouteDescriptor routeDescriptor in GetRoutes())
            {
                routes.Add(routeDescriptor);
            }
        }

        public IEnumerable<RouteDescriptor> GetRoutes()
        {
            return new[] {
                new RouteDescriptor {
                    Route = new Route(
                        "download/{*url}",
                        new RouteValueDictionary {
                            {"area", "Amba.DownloadsCounter"},
                            {"controller", "DownloadCounter"},
                            {"action", "Index"}
                        },
                        new RouteValueDictionary(),
                        new RouteValueDictionary {
                            {"area", "Amba.DownloadsCounter"}
                        },
                        new MvcRouteHandler())
                }
            };
        }

        #endregion
    }
}